# coding: utf-8

"""
    Pulp 3 API

    Fetch, Upload, Organize, and Distribute Software Packages

    The version of the OpenAPI document: v3
    Contact: pulp-list@redhat.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from pulpcore.client.pulp_container.models.media_types_enum import MediaTypesEnum
from typing import Optional, Set
from typing_extensions import Self

class ManifestCopy(BaseModel):
    """
    Serializer for copying manifests from a source repository to a destination repository.
    """ # noqa: E501
    source_repository: Optional[StrictStr] = Field(default=None, description="A URI of the repository to copy content from.")
    source_repository_version: Optional[StrictStr] = Field(default=None, description="A URI of the repository version to copy content from.")
    digests: Optional[List[Any]] = Field(default=None, description="A list of manifest digests to copy.")
    media_types: Optional[List[MediaTypesEnum]] = Field(default=None, description="A list of media_types to copy.")
    __properties: ClassVar[List[str]] = ["source_repository", "source_repository_version", "digests", "media_types"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ManifestCopy from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ManifestCopy from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "source_repository": obj.get("source_repository"),
            "source_repository_version": obj.get("source_repository_version"),
            "digests": obj.get("digests"),
            "media_types": obj.get("media_types")
        })
        return _obj


